import java.awt.*;
import java.awt.image.*;
import java.awt.Graphics;
import java.io.*;
import javax.swing.*;
import javax.imageio.*;
import java.awt.geom.Rectangle2D;


public class CropResize extends JApplet{
	int[] pix;
	int height, width, croppedW, croppedH;
	Image image;


	// This method returns an Image object from a buffered image
    
	public static Image toImage(BufferedImage bufferedImage) {
        return Toolkit.getDefaultToolkit().createImage(bufferedImage.getSource());
    }
	public CropResize(int wPar, int hPar, int[] pixPar){
		width=wPar;
		height=hPar;
		pix=pixPar;
		image = createImage(new MemoryImageSource(width, height, pix, 0, width));
	}
	public Image getImage(){
		return image;
	}
	public int getCroppedW(){
		return croppedW;
	}
	public int getCroppedH(){
		return croppedH;
	}
	private void fillshape(int[] input, int[] processed, int[] areas, int X, int Y, int value, int recurs){
		//set this processed value
		processed[Y*width+X]=value;
		areas[value]++;
					
		if (recurs<5000){
			if(X<width-1 && input[Y*width+X+1]!=-16777216 && processed[Y*width+X+1]==0){
			 	fillshape(input, processed, areas, X+1, Y, value, recurs+1);
					//	System.out.println("Right"+value);
			}
			if(X>1 && input[Y*width+X-1]!=-16777216 && processed[Y*width+X-1]==0){
				 fillshape(input, processed, areas, X-1, Y, value, recurs+1);
			
				//		System.out.println("left"+value);
			}
			if(Y<height-1 && input[(Y+1)*width+X]!=-16777216 && processed[(Y+1)*width+X]==0){
				fillshape(input, processed, areas, X, Y+1, value, recurs+1);
				//		System.out.println("Above"+value);
			}
			if(Y>1 && input[(Y-1)*width+X]!=-16777216 && processed[(Y-1)*width+X]==0){
				 fillshape(input, processed, areas, X, Y-1, value, recurs+1);

				//		System.out.println("Below"+value);
			}
		}
		return;
	}
	//returns new image, and updates width and height variables
	private int[] cropImage(int[] input) {

		int[] output = new int[4];

		int[] processed = new int[width*height];

		int[] areas  = new int[width*height];

		int index=0;

		for(int x=0; x<width;x++) {
			for(int y=0; y<height;y++) {
				processed[y*width+x]=0;
				areas[y*width+x]=0;
			}
		}

		int max=0, maxIndex=0;
		for(int x=0; x<width;x++) {
			for(int y=0; y<height;y++) {
				if(input[y*width+x]!=-16777216 && processed[y*width+x]==0){
					index++;
					fillshape(input, processed, areas, x, y, index, 0);
					if(max<areas[index]){
						max=areas[index];
						maxIndex=index;
					}
				}
			}
		}
		//System.out.println("Largest area: "+ maxIndex+" val: "+max);

		int Xmin=width, Xmax=0, Ymin=height, Ymax=0;

		for(int x=0; x<width;x++) {
			for(int y=0; y<height;y++) { 
				if(processed[y*width+x]==maxIndex){
					if(x<Xmin)
						Xmin=x;
					if(y<Ymin)
						Ymin=y;
					if(x>Xmax)
						Xmax=x;
					if(y>Ymax)
						Ymax=y;
				}
			}
		}

		Xmin=Xmin-1;
		Xmax=Xmax+2;
		Ymin=Ymin-1;
		Ymax=Ymax+2;
		if(Xmin<0)
			Xmin=0;
		if(Ymin<0)
			Ymin=0;
		if(Xmax>width)
			Xmax=width;
		if(Ymax>height)
			Ymax=height;

		//int oldWidth=width, oldHeight=height;

		//update new width and height info
		croppedW=Xmax-Xmin;						
		croppedH=Ymax-Ymin;

		int[] cropData = new int[croppedW*croppedH];

		//System.out.println("cropping to: "+ Xmin+" "+Xmax+" "+Ymin+" "+Ymax);

		for(int x=0; x<croppedW; x++) {
			for(int y=0; y<croppedH; y++) {
				if(processed[(y+Ymin)*width+(x+Xmin)]==maxIndex)
					cropData[y*croppedW+x]=input[(y+Ymin)*width+(x+Xmin)];
				else
					cropData[y*croppedW+x]=-16777216;
			}
		}

		return cropData;
	}

	public static class BatchProcess extends JApplet{
		int[] widths;
		int[] heights;

		public BatchProcess(String pathname){

			File theFile = new File(pathname);
			File[] theFiles;
			if (theFile.isDirectory()){



			 	theFiles=theFile.listFiles();

				widths=new int[theFiles.length];
				heights=new int[theFiles.length];
				for (int files=0; files<theFiles.length; files++){
					try{
						if(!(theFiles[files].getName()).endsWith("png"))
								continue;
						Image image = ImageIO.read(theFiles[files]);
						String filename=theFiles[files].getName();
						int w = image.getWidth(null);
						int h = image.getHeight(null);
						w=w/2;
						h=h/2;
						image = image.getScaledInstance(w,h,BufferedImage.SCALE_DEFAULT);
						BufferedImage imageb = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
						Graphics2D bufImageGraphics = imageb.createGraphics();
				  		bufImageGraphics.drawImage(image, 0, 0, null);
						int[] pixels = new int[w * h];
					    imageb.getRGB(0, 0, w, h, pixels, 0, w);
						int white=0, black=0;
						for (int i=0; i<pixels.length; i++){
							if (pixels[i]==-16777216) black++;
							else if(pixels[i]==-1)  white++;
						}
						//System.out.println("Black = "+black+", white = "+white);
						CropResize pc2 = new CropResize(w,h,pixels);
						int[] croppedPixels = pc2.cropImage(pixels);
						black=0;
						white=0;
						for (int i=0; i<croppedPixels.length; i++){
							if (croppedPixels[i]==-16777216) black++;
							else if(croppedPixels[i]==-1)  white++;
						}
						//System.out.println("Black = "+black+", white = "+white);
						int cropW=pc2.getCroppedW();
						int cropH=pc2.getCroppedH();
						widths[files]=cropW;
						heights[files]=cropH;

					}catch(IOException ioe){ioe.printStackTrace();}
				}
				int Xmax=0, Ymax=0, Xmax1=0, Ymax1=0;
				for (int files=0; files<theFiles.length; files++){
					if(Xmax<widths[files]){
						Xmax=widths[files];
						Xmax1=files;
					}
					if(Ymax<heights[files]){
						Ymax=heights[files];
						Ymax1=files;
					}
				}
				System.out.println("widthMAX: "+ Xmax+" heightMAX: "+Ymax+" - ");
				float Xratio;
				Xratio=64/(float)Xmax;
				float Yratio;
				Yratio=64/(float)Ymax;
				System.out.println("Xratio: "+ Xratio+" Yratio: "+Yratio);

				for (int files=0; files<theFiles.length; files++){
					try{
						if(!(theFiles[files].getName()).endsWith("png"))
								continue;
						Image image = ImageIO.read(theFiles[files]);
						String filename=theFiles[files].getName();

						System.out.println("processing: "+ filename);
						int w = image.getWidth(null);
						int h = image.getHeight(null);
						w=w/2;
						h=h/2;
						image = image.getScaledInstance(w,h,BufferedImage.SCALE_DEFAULT);
						BufferedImage imageb = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
						Graphics2D bufImageGraphics = imageb.createGraphics();
				  		bufImageGraphics.drawImage(image, 0, 0, null);
						int[] pixels = new int[w * h];
					    imageb.getRGB(0, 0, w, h, pixels, 0, w);
						int white=0, black=0;
						for (int i=0; i<pixels.length; i++){
							if (pixels[i]==-16777216) black++;
							else if(pixels[i]==-1)  white++;
						}
						//System.out.println("Black = "+black+", white = "+white);
						CropResize pc2 = new CropResize(w,h,pixels);
						int[] croppedPixels = pc2.cropImage(pixels);
						black=0;
						white=0;
						for (int i=0; i<croppedPixels.length; i++){
							if (croppedPixels[i]==-16777216) black++;
							else if(croppedPixels[i]==-1)  white++;
						}
						//System.out.println("Black = "+black+", white = "+white);
						int cropW=pc2.getCroppedW();
						int cropH=pc2.getCroppedH();
						widths[files]=cropW;
						heights[files]=cropH;

						CropResize pc2a = new CropResize(cropW,cropH,croppedPixels);
						Image croppedImage=pc2a.getImage();




						int newwidth,newheight;
						newwidth=(int)(cropW*Yratio);
						newheight=(int)(cropH*Yratio);
						Image scaledImage=croppedImage.getScaledInstance(newwidth,newheight,Image.SCALE_DEFAULT);
						BufferedImage scaledbufferedImage = new BufferedImage ( newwidth, newheight, BufferedImage.TYPE_INT_BGR  );
						scaledbufferedImage.createGraphics().drawImage( scaledImage, 0, 0, this /* observer */ );

						int rowNum=15;
						int bodyLeft, bodyRight;
						//right border
						int x;
						for (x=newwidth-1; x>0; x--){
						//	System.out.println(scaledbufferedImage.getRGB(x,rowNum));
							if(scaledbufferedImage.getRGB(x,rowNum)!=-16777216) break;
						}
						bodyRight=x;

						//left border
						for (x=1; x<newwidth; x++){
							if(scaledbufferedImage.getRGB(x,rowNum)!=-16777216) break;
						}
						bodyLeft=x;
						float midpoint;
						int bodywidth;
						bodywidth=bodyRight-bodyLeft;
						midpoint=bodyLeft+((bodyRight-bodyLeft)/2);

						System.out.println("left "+bodyLeft+" midpoint = "+midpoint+" right = "+bodyRight);


						String outFilename= filename.substring(0,filename.length()-4).concat("_scaled.png");
						BufferedImage scaledImageb = new BufferedImage(64, 64, BufferedImage.TYPE_INT_ARGB);
						bufImageGraphics = scaledImageb.createGraphics();
						bufImageGraphics.setColor(Color.black);
				  		bufImageGraphics.fill(new Rectangle2D.Float(0, 0, 64, 64));

						bufImageGraphics.drawImage(scaledImage, (int)(32-bodyLeft - (int)(bodywidth/2)), (int)((64-newheight)/2), null);
						//bufImageGraphics.drawImage(scaledImage, (int)((64-newwidth)/2), (int)((64-newheight)/2), null);

						ImageIO.write(scaledImageb, "png", new File(pathname,outFilename));
					}catch(IOException ioe){ioe.printStackTrace();}
				}

			}
		}
	
	}	

public static void main(String[] argv){
	String pathname = argv[0];
	BatchProcess b;
	for(int i=0; i<argv.length; i++)
		b = new BatchProcess(argv[i]);

//	         GetUSCapital MyCa=new GetUSCapital();
}
}

